#!/sw/bin/perl

$self = $0;
$self =~ s!^.*[/\\]!!;
$self =~ s!\.+(?:pl|sh|bat)?$!!i;

$ignore_case = 0;
$ignore_case = shift if ((@ARGV > 0) and ($ARGV[0] eq '-i'));

die "Usage: $self [-i] <perlregexp>\n" unless (@ARGV);

$pattern = shift;

eval { $self =~ /$pattern/o; };

if ($@)
{
    $@ =~ s!\s+$!!;
    $@ =~ s!\s+at\s.+$!!;
    die "$self: $@\n";
}

@dirs = split(/:/, $ENV{'PATH'});

foreach $dir (@dirs)
{
    next unless -d $dir;
    unless (opendir(DIR, $dir))
    {
        warn "can't open dir '$dir': $!\n";
        next;
    }
    @files = readdir(DIR);
    unless (closedir(DIR))
    {
        warn "can't close dir '$dir': $!\n";
    }
    foreach $item (@files)
    {
        next if $item =~ /^\.\.?$/;
        $file = "$dir/$item";
        next unless -f $file;
        if ($ignore_case) { print "$file\n" if $item =~ /$pattern/io; }
        else              { print "$file\n" if $item =~ /$pattern/o;  }
 
    }
}

__END__

